#include<stdio.h>
int main(){
	int k,n;
	scanf("%d",&n);
	int niz[n];
	scanf("%d",&k);
	int r,r2,r3,r4;
	for(int i=0;i<n;i++){
		scanf("%d",&niz[i]);
	
		
		
		r=niz[0]-niz[n-1];
		r2=niz[n-1]-niz[0];
		
	
		
		
}
	
	
	if(r>0&&r2>0){
	
	if(r<r2)printf("%d",r2);
	else printf("%d",r);
}
    if(r<0&&r2>0){
    	printf("%d",r2);
	
    	
	}
	int max;
	if(r>0&&r2<0){
		
		printf("%d",r);
	}
}